package discver

import (
	"context"
	"github.com/go-kratos/kratos/v2/log"
	grpc1 "github.com/go-kratos/kratos/v2/transport/grpc"
	"google.golang.org/grpc"
)

// GrpcDial 服务方法发现
func (reg *Registry) GrpcDial(ctx context.Context, serverName, f string) {

}

// GrpcInsecure 服务发现
func (reg *Registry) GrpcInsecure(ctx context.Context, serverName string) (*grpc.ClientConn, error) {
	endpoint := "discovery:///" + serverName
	conn, err := grpc1.DialInsecure(ctx, grpc1.WithEndpoint(endpoint), grpc1.WithDiscovery(reg.r))
	if err != nil {
		log.Error("grpc insecure error:%v", err)
	}
	return conn, err
}
