package discver

import (
	"git.gz.internal.jumaiyx.cn/jm/jmproto/conf"
	cli "git.gz.internal.jumaiyx.cn/pkg/go-etcd/client"
	"github.com/go-kratos/kratos/contrib/registry/etcd/v2"
	clientv3 "go.etcd.io/etcd/client/v3"
	"sync"
	"time"
)

var (
	mu sync.Mutex
)

type Registry struct {
	r      *etcd.Registry
	client *clientv3.Client
}

// NewConfDial config file dial
//func NewConfRegistry(c config.Config) (*Registry, error) {
//	var bc cli.Data
//	if err := c.Scan(&bc); err != nil {
//		return nil, err
//	}
//	return getRegistry(&bc.Etcd)
//}

// NewRegistry parameters dial
func NewRegistry(bc *conf.Etcd) (*Registry, error) {
	return getRegistry(bc)
}

func (reg *Registry) GetReg() *etcd.Registry {
	return reg.r
}

func (reg *Registry) Close() error {
	//reg.client.Close()
	return nil
}

func (reg *Registry) GetActiveTime() time.Time {
	return time.Now()
}

//discard
func getRegistry(bc *conf.Etcd) (*Registry, error) {
	mu.Lock()
	defer mu.Unlock()
	conf, err := cli.Conf(bc)
	if err != nil {
		return nil, err
	}
	c, err := cli.Client(*conf)
	if err != nil {
		return nil, err
	}
	return &Registry{
		r:      etcd.New(c),
		client: c,
	}, nil
}
