package go_etcd

import (
	"context"
	"git.gz.internal.jumaiyx.cn/jm/jmproto/conf"
	"git.gz.internal.jumaiyx.cn/pkg/go-etcd/client"
	"git.gz.internal.jumaiyx.cn/pkg/go-etcd/discver"
	"github.com/go-kratos/kratos/v2/log"
	"testing"
)

func TestDial(t *testing.T) {
	ctx := context.Background()
	c := &conf.Etcd{
		Host:    "127.0.0.1:20000",
		Timeout: 3,
	}
	cli, err := client.NewClient(c)
	if err != nil {
		t.Fatal(err)
	}
	get, err := cli.Get(ctx, "/microservices/helloword/jm9001")
	if err != nil {
		t.Fatal(err)
	}
	log.Info(get)
}

func TestNewEtcd(t *testing.T) {
	p, err := discver.NewEtcd(&discver.RegistryConfig{
		Conf: &conf.Etcd{
			Host: "127.0.0.1:20000",
		},
		MinOpen: 10,
	}).Pool()
	if err != nil {
		log.Error(err)
	}
	get, err := p.Get()
	if err != nil {
		log.Error(err)
	}
	_, err = get.GrpcInsecure(context.Background(), "serverName")
	if err != nil {
		log.Error(err)
	}
	//p.Close()
}

func TestNewReg(t *testing.T) {
	//c := &conf.Etcd{
	//	Host: "127.0.0.1:20000",
	//}

}
